//CompositeurAdobe_404f.js / CS4
// 17.11.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Ce script sert  changer le compositeur Adobe (paragraphe ou ligne simple)

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// relever la langue du programme
var curLang = app.locale;
if (curLang == 1279477362) {
	paraComp = "Compositeur de paragraphe Adobe";
	singComp = "Compositeur ligne simple Adobe";
}
else if (curLang == 1279477613) {
	paraComp = "Adobe-Absatzsetzer";
	singComp = "Adobe Ein-Zeilen-Setzer";
}
else if (curLang == 1279477102) {
	paraComp = "Adobe Paragraph Composer";
	singComp = "Adobe Single-Line Composer";
}
else {
	alert ("Le script ne fonctionne pas avec cette langue du programme.\rVeuillez envoyer un message  l'auteur:\rHans Haesler <hsa@ringier.ch>", "Stop");
	exit();
}

// appeler la fonction qui lit le fichier avec les rglages mmoriss
var defStr = getPrefs();
// extraire les valeurs
if (defStr != "") {
	var compDef = defStr.split("\n");
	jChck0 = compDef[0];
	if (jChck0 == "false") {jChck0 = false;}
	else {jChck0 = true;}
	jChck1 = compDef[1];
	if (jChck1 == "false") {jChck1 = false;}
	else {jChck1 = true;}
	jChck2 = compDef[2];
	if (jChck2 == "false") {jChck2 = false;}
	else {jChck2 = true;}
	rChck0 = compDef[3];
	if (rChck0 == "false") {rChck0 = false;}
	else {rChck0 = true;}
	rChck1 = compDef[4];
	if (rChck1 == "false") {rChck1 = false;}
	else {rChck1 = true;}
	rChck2 = compDef[5];
	if (rChck2 == "false") {rChck2 = false;}
	else {rChck2 = true;}
	nChckJ = compDef[6];
	if (nChckJ == "false") {nChckJ = false;}
	else {nChckJ = true;}
	jChck3 = compDef[7];
	if (jChck3 == "false") {jChck3 = false;}
	else {jChck3 = true;}
	jChck4 = compDef[8];
	if (jChck4 == "false") {jChck4 = false;}
	else {jChck4 = true;}
	nChckR = compDef[9];
	if (nChckR == "false") {nChckR = false;}
	else {nChckR = true;}
	rChck3 = compDef[10];
	if (rChck3 == "false") {rChck3 = false;}
	else {rChck3 = true;}
	rChck4 = compDef[11];
	if (rChck4 == "false") {rChck4 = false;}
	else {rChck4 = true;}
}
else {
	jChck0 = false;
	jChck1 = false;
	jChck2 = true;
	rChck0 = false;
	rChck1 = false;
	rChck2 = true;
	nChckJ = false;
	jChck3 = false;
	jChck4 = true;
	nChckR = false;
	rChck3 = false;
	rChck4 = true;
}	

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// prparer le dialogue
var aDialog = app.dialogs.add({name:"Compositeur Adobe", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		var jstGroup = enablingGroups.add({staticLabel:"Feuilles de style justifies", checkedState:jChck0});
		with (jstGroup){
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var jstButtons = radiobuttonGroups.add();
					with (jstButtons) {
						radiobuttonControls.add({staticLabel:paraComp, checkedState:jChck1, minWidth:190});
						radiobuttonControls.add({staticLabel:singComp, checkedState:jChck2});
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:""});
		}
		var ragGroup = enablingGroups.add({staticLabel:"Feuilles de style en drapeau", checkedState:rChck0});
		with (ragGroup){
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var ragButtons = radiobuttonGroups.add();
					with (ragButtons) {
						radiobuttonControls.add({staticLabel:paraComp, checkedState:rChck1, minWidth:190});
						radiobuttonControls.add({staticLabel:singComp, checkedState:rChck2});
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:""});
		}
		var noGroupJ = enablingGroups.add({staticLabel:"[Aucun style]: texte justifi", checkedState:nChckJ});
		with (noGroupJ){
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var noButtonsJ = radiobuttonGroups.add();
					with (noButtonsJ) {
						radiobuttonControls.add({staticLabel:paraComp, checkedState:jChck3, minWidth:190});
						radiobuttonControls.add({staticLabel:singComp, checkedState:jChck4});
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:""});
		}
		var noGroupR = enablingGroups.add({staticLabel:"[Aucun style]: texte en drapeau", checkedState:nChckR});
		with (noGroupR){
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var noButtonsR = radiobuttonGroups.add();
					with (noButtonsR) {
						radiobuttonControls.add({staticLabel:paraComp, checkedState:rChck3, minWidth:190});
						radiobuttonControls.add({staticLabel:singComp, checkedState:rChck4});
					}
				}
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}

// montrer le dialogue
if (aDialog.show() == true) {
	// mmoriser le choix de l'utilisateur
	var doJst = jstGroup.checkedState;
	jChck0 = doJst;
	var doRag = ragGroup.checkedState;
	rChck0 = doRag;
	var noJst = noGroupJ.checkedState;
	nChckJ = noJst;
	var noRag = noGroupR.checkedState;
	nChckR = noRag;
	if (doJst != true && doRag != true && noJst != true && noRag != true) {
		alert ("Il n'y avait pas de slection.", "Attention");
		aDialog.destroy();
		exit();
	}
	if (doJst == true) {
		var jType = jstButtons.selectedButton;
		if (jType == 0) {
			var compParaJst = true;
			jChck1 = true;
			jChck2 = false;
		}
		else {
			var compParaJst = false;
			jChck1 = false;
			jChck2 = true;
		}
	}
	if (doRag == true) {
		var rType = ragButtons.selectedButton;
		if (rType == 0) {
			var compParaRag = true;
			rChck1 = true;
			rChck2 = false;
		}
		else {
			var compParaRag = false;
			rChck1 = false;
			rChck2 = true;
		}
	}
	if (noJst == true) {
		var nType1 = noButtonsJ.selectedButton;
		if (nType1 == 0) {
			var noParaJst = true;
			jChck3 = true;
			jChck4 = false;
		}
		else {
			var noParaJst = false;
			jChck3 = false;
			jChck4 = true;
		}
	}
	if (noRag == true) {
		var nType2 = noButtonsR.selectedButton;
		if (nType2 == 0) {
			var noParaRag = true;
			rChck3 = true;
			rChck4 = false;
		}
		else {
			var noParaRag = false;
			rChck3 = false;
			rChck4 = true;
		}
	}
	// effacer le dialogue
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// composer une chane de texte avec les rglages
var tmpList = new Array (jChck0, jChck1, jChck2, rChck0, rChck1, rChck2, nChckJ, jChck3, jChck4, nChckR, rChck3, rChck4);
var curDef = tmpList.join("\n");
// appeler la fonction qui crit le rsultat dans un fichier
writeResult(curDef);

// dresser la liste des feuilles de style de paragraphe
var allParaStyles = app.documents[0].paragraphStyles;

// une boucle  travers les feuilles de styles
var curJust;
for (var i=1; i<allParaStyles.length; i++) {
	try {
		curJust = allParaStyles[i].justification;
		// les valeurs dcimales des quatre options "bloc" (la justification est celle de la ligne creuse)
		// 1818915700 =  gauche; 1919578996 = centre, 1667920756 =  droite; 1718971500 = plein
		if (curJust == 1818915700 || curJust == 1919578996 || curJust == 1667920756 || curJust == 1718971500) {
			if (doJst) {
				if (compParaJst) {
					allParaStyles[i].composer = paraComp;
				}
				else {
					allParaStyles[i].composer = singComp;
				}
			}
		}
		// sinon, il s'agit d'une option en drapeau
		else {
			if (doRag) {
				if (compParaRag) {
					allParaStyles[i].composer = paraComp;
				}
				else {
					allParaStyles[i].composer = singComp;
				}
			}
		}
	}
	catch (e) {
	}
}

// une autre boucle  travers des groupes
curGroups = app.documents[0].paragraphStyleGroups;
var nParaStyleGroups = curGroups.length;	
for (var i=0; i<nParaStyleGroups; i++) {
	var curGroup = curGroups[i];		
	var curParaStyles = curGroup.allParagraphStyles;
	var nParaStyles = curParaStyles.length;
		for (var k=0; k<nParaStyles; k++) {
		try {
			curJust = curParaStyles[k].justification;
			if (curJust == 1818915700 || curJust == 1919578996 || curJust == 1667920756 || curJust == 1718971500) {
				if (doJst) {
					if (compParaJst) {
						curParaStyles[k].composer = paraComp;
					}
					else {
						curParaStyles[k].composer = singComp;
					}
				}
			}
			// sinon, il s'agit d'une option en drapeau
			else {
				if (doRag) {
					if (compParaRag) {
						curParaStyles[k].composer = paraComp;
					}
					else {
						curParaStyles[k].composer = singComp;
					}
				}
			}
		}
			catch (e) {
		}
	}
}

// au besoin, trater galement les textes sans feuilles de style
if (noJst == true || noRag == true) {
	var curStory;
	var curPara;
	var noStyleName = app.documents[0].paragraphStyles[0].name;
	var allStories = app.documents[0].stories;
	for (var i=0; i<allStories.length; i++) {
		curStory = allStories[i];
		for (var j=0; j<curStory.paragraphs.length; j++) {
			curPara = curStory.paragraphs[j];
			if (curPara.appliedParagraphStyle.name == noStyleName) {
				curJust = curPara.justification;
				if (curJust == 1818915700 || curJust == 1919578996 || curJust == 1667920756 || curJust == 1718971500) {
					if (noJst) {
						if (noParaJst) {
							curPara.composer = paraComp;
						}
						else {
							curPara.composer = singComp;
						}
					}
				}
				// sinon, il s'agit d'une option en drapeau
				else {
					if (noRag) {
						if (noParaRag) {
							curPara.composer = paraComp;
						}
						else {
							curPara.composer = singComp;
						}
					}
				}
			}
		}
	}
}

// informer l'utilisateur
alert("C'est fait.", " ");


/*-------------------------------*/

// la fonction qui lit le fichier
function getPrefs() {
	var defStr = "";
	var f = new File("~/Library/Preferences/compPrefs.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// la fonction qui crit le fichier
function writeResult(curDef) {
	var f = new File("~/Library/Preferences/compPrefs.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		f.encoding = "ISO-8851-9" 
		f.write(curDef);
		f.close();
	}
}